using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {

            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Red Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("red protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("red protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head1.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail1.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Orange Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("orange protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("orange protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head2.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail2.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Yellow Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("yellow protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("yellow protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head3.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail3.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Green Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("green protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("green protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head4.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail4.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Dark Green Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("dark green protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("dark green protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head5.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail5.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Seafoam Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("seafoam protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("seafoam protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head6.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail6.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Cyan Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("cyan protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("cyan protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head7.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail7.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Blue Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("blue protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("blue protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head8.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail8.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Dark Blue Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("dark blue protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("dark blue protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head9.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail9.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Purple Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("purple protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("purple protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head10.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail10.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Pink Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("pink protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("pink protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head11.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail11.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Brown Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("brown protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("brown protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head12.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail12.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Black Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("black protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("black protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head13.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail13.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Gray Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("gray protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("gray protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head14.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail14.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "White Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("white protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("white protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head15.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail15.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Love Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry who wants to be your friend",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("love protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("love protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light2.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head16.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail16.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Rainbow Protogen",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry with rainbow colors",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("rainbow protogen frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("rainbow protogen.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head1.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail17.png"); 	
                  }
              }
            );

        }
    }
}

public class Purp : Liquid
{
    public Purp()
    {
        this.Color = new Color32(51, 153, 255, 0);
    }

    public override void OnEnterContainer(BloodContainer container)
    {
    }

    public override void OnEnterLimb(LimbBehaviour limb)
    {
        if (limb.SpeciesIdentity == "Human" && UnityEngine.Random.value > 0.995f)
        {
            limb.PhysicalBehaviour.Charge += 0.1f;
        }
    }

    public override void OnExitContainer(BloodContainer container)
    {
    }
                                         public const string ID = "BLAU";
                                 }
    

